<< problem 455 - Powers With Trailing Digits | Almost Pi - problem 461 >> |
Problem 458: Permutations of Project
(see projecteuler.net/problem=458)
Consider the alphabet A made out of the letters of the word "project": A= \{c,e,j,o,p,r,t\}.
Let T(n) be the number of strings of length n consisting of letters from A that do not have a substring that is one of the 5040 permutations of "project".
T(7)=7^7 - 7! = 818503.
Find T(10^12). Give the last 9 digits of your answer.
My Algorithm
First let's state the most important property of the word "project": all its letters are distinct.
I wrote three (!) algorithms but only the last actually solves T(10^12) in a reasonable amount of time (function fast
):
bruteForce()
was a quick hack to ensure I can solve T(n) for small parameters (n < 10 is okay)
It iterates over all possible 7^n strings and checks every subset of 7 consecutive letters whether they can produce the word "project".
I assign each letter P,R,O,J,E,C,T a number between 0 and 6 which in turn is used as the position in a bitmask.
Only if seven consecutive letters are distinct then the ORed bitmask of those seven letters will be 1111111 in binary (= 2^7 - 1 = 127 in decimal).
The next algorithm's implementation is the function slow
. It works quite differently because it treats the whole thing as a state machine:
- I count the number of strings WITH the word "project"
- → then the result is 7^n minus that number of strings with the word "project"
- in general: if the last x letters were distinct then the state machine is currently in state x
- the state machine has 8 states (0 to 7) and starts in state 0
- once state 7 is reached it stays there
state[8] = { 1,0,0,0,0,0,0,0 }
because there is only one empty string and it's in state 0.No empty string can be in state 1,2,...,7.
When the first letter is processed then there are 7 different letters. Each causes a transition from state 0 to state 1.
When the second letter is processed then there are 7 differenz letters as well but I have to be careful:
if the second letter is equal to the first letter, then I remain in state 1 else I jump to state 2.
Remember: the current state's ID indicates how many of the last letters were distinct.
When the third letter is processed then there are 3 different state transitions:
- if the new letter is equal to the first letter, then the state machine stays in state 2
- if the new letter is equal to the second letter, then the state machine must go back to state 1
- if the new letter wasn't seen before then the state machine proceeds with state 3
State 7 stands out because once I reach state 7 then I stay there, no matter what future letters will arrive.
That's because I'm interesting in all strings containing the word "project" at least once - and it doesn't matter if it appears 1x, 10x, 100x, ...
I wrote a simple loop that repeatedly adds/multiplies each state by the number of different state transitions.
That O(n) algorithm can solve T(10^12) in a few hours - still too slow !
So I wrote the
fast()
function: the state transitions look a lot like a matrix - why not rewrite it as a Matrix
?The matrix's number at position x,y contains the number of transitions from state x to state y.
For example, M_{4,5} =
M[4,5] = 3
because 3 (out of 7) letters cause a transition from state 4 to 5.You'll find it in the fifth column and sixth line (the upper-right corner has index (0,0) because I used zero-based indices):
M = \begin{pmatrix} 0 & 0 & 0 & 0 & 0 & 0 & 0 & 0 \\ 7 & 1 & 1 & 1 & 1 & 1 & 1 & 0 \\ 0 & 6 & 1 & 1 & 1 & 1 & 1 & 0 \\ 0 & 0 & 5 & 1 & 1 & 1 & 1 & 0 \\ 0 & 0 & 0 & 4 & 1 & 1 & 1 & 0 \\ 0 & 0 & 0 & 0 & 3 & 1 & 1 & 0 \\ 0 & 0 & 0 & 0 & 0 & 2 & 1 & 0 \\ 0 & 0 & 0 & 0 & 0 & 0 & 1 & 7 \end{pmatrix}
The
state
variable'' looks like a vector such that the computation per step is:(1) state_{i+1} = M \bullet state_i
And the next step:
(2) state_{i+2} = M \bullet state_{i+1}
(3) state_{i+2} = M \bullet (M \bullet state_i)
(4) state_{i+2} = (M \bullet M) \bullet state_i
(5) state_{i+2} = M^2 \bullet state_i
The last equation can be generalized to:
(6) state_{final} = M^n \bullet state_0
When solving problem 137 I wrote a fast exponentiation algorithm for a 2x2 matrix.
The
Matrix
class written for the current problem generalizes that algorithm to larger quadratic matrices, see its powmod
member function.I was too lazy to write a
Vector
class to represent the state
variable - and I can get away with that lazy attitude ;-)The meaning of M^n_{x,y} was that the matrix M contains the total number of state transitions from state x to y after n steps.
Hence M^n_{0,7} is the total number of strings with the word "project" after those n = 10^12 steps.
Now I need 7^n mod 10^9 - and that number is part of the matrix, too !
The number M_{7,7} is initially 7 and multiplied by itself n times, that's exactly what I need.
However, I saw that M^n_{7,7} = 1 after n = 10^12 steps - which I found strange and I was sure I had a bug in my code.
But Wolfram Alpha confirmed that it's correct: www.wolframalpha.com/input/?i=PowerMod[7,10^12,10^9]
So the result is M^n_{7,7} - M^n_{0,7} (mod 1000000000).
Fast exponentiation is truly fast and the correct result is displayed after a few milliseconds.
Alternative Approaches
After submitting my result I looked at the official forum and noticed that pretty much everyone solved it the same way.
But some postings differed completely: they found the generating function and solved it.
Interactive test
You can submit your own input to my program and it will be instantly processed at my server:
This is equivalent toecho 7 | ./458
Output:
Note: the original problem's input 1000000000000
cannot be entered
because just copying results is a soft skill reserved for idiots.
(this interactive test is still under development, computations will be aborted after one second)
My code
… was written in C++11 and can be compiled with G++, Clang++, Visual C++. You can download it, too. Or just jump to my GitHub repository.
#include <iostream>
#include <array>
// "project" has 7 distinct letters
const auto WordSize = 7;
enum Letters { P = 0, R = 1, O = 2, J = 3, E = 4, C = 5, T = 6 };
// only the last nine digits
const unsigned int Modulo = 1000000000;
// ---------- first algorithm ----------
// super-slow brute-force algorithm, becomes unusable for numLetters > 10
unsigned long long bruteForce(unsigned int numLetters)
{
// bruteForce( 7) = 818503
// bruteForce( 8) = 5699280
// bruteForce( 9) = 39688327
// bruteForce(10) = 276386929
unsigned long long result = 0;
// 7^numLetters
unsigned long long maxId = 1;
for (unsigned long long exponent = 1; exponent <= numLetters; exponent++)
maxId *= WordSize;
// iterate over all 7^numLetters combinations
for (unsigned long long i = 0; i < maxId; i++)
{
// convert the current number to letters (it's like converting from decimal to base 7)
auto id = i;
Letters letters[20];
for (unsigned int letter = 0; letter < numLetters; letter++)
{
// I use the data type "Letters" to simplify debugging
letters[letter] = (Letters)(id % WordSize);
id /= WordSize;
}
// look at each group of 7 consecutive letters
bool isProject = false;
for (unsigned int from = 0; from + WordSize <= numLetters; from++)
{
// build a bitmask:
unsigned int mask = 0;
for (unsigned int current = 0; current < WordSize; current++)
mask |= 1 << letters[from + current];
// all seven letters used ?
if (mask == 127) // 2^7 - 1 = 127
{
isProject = true;
break;
}
}
// no seven consecutive letters can be re-order to the word "PROJECT"
if (!isProject)
result++;
}
return result;
}
// ---------- second algorithm ----------
// O(n) algorithm, needs about 2 seconds for numLetters = 10^8
unsigned long long slow(unsigned long long numLetters)
{
// state x means that currently x distinct letters were observed in the last x steps
typedef std::array<unsigned long long, 7 + 1> State;
// once we reach state 7 we have the word P,R,O,J,E,C,T (in any order) and remain in that state
// no matter what follows
State state = { 0 };
state[0] = 1; // seed
unsigned long long all = 1;
for (unsigned long long i = 1; i <= numLetters; i++)
{
// total number of strings (regardless whether they contain PROJECT or not)
all *= 7;
all %= Modulo;
State next = { 0 };
// compute all state transitions
next[1] = 7 * state[0] + 1 * state[1] + 1 * state[2] + 1 * state[3] + 1 * state[4] + 1 * state[5] + 1 * state[6];
next[2] = 6 * state[1] + 1 * state[2] + 1 * state[3] + 1 * state[4] + 1 * state[5] + 1 * state[6];
next[3] = 5 * state[2] + 1 * state[3] + 1 * state[4] + 1 * state[5] + 1 * state[6];
next[4] = 4 * state[3] + 1 * state[4] + 1 * state[5] + 1 * state[6];
next[5] = 3 * state[4] + 1 * state[5] + 1 * state[6];
next[6] = 2 * state[5] + 1 * state[6];
next[7] = + 1 * state[6];
// once I'm in state 7 I stay there
next[7] += 7 * state[7];
// keep only the last 9 digits
for (auto& x : next)
x %= Modulo;
state = std::move(next);
}
// state[7] represents the number of strings WITH the word "project"
auto withProject = state[7];
// without = all - with, but avoid negative results (due to modulo)
if (all < withProject)
all += Modulo;
return all - withProject;
}
// ---------- third and final algorithm ----------
// quadratic 2D matrix
template <typename Number, unsigned int Size>
class Matrix
{
// store all elements
std::array<std::array<Number, Size>, Size> data; // same as Number data[Size][Size];
public:
// set all elements to zero
Matrix()
: data()
{
for (unsigned int i = 0; i < Size; i++)
data[i].fill(0);
}
// access a field (read/write), indices are zero-based
Number& operator()(unsigned int column, unsigned int row)
{
return data[row][column];
}
// access a field (read-only), indices are zero-based
Number get(unsigned int column, unsigned int row) const
{
return data[row][column];
}
// multiply two matrices
Matrix operator*(const Matrix& other) const
{
Matrix result; // initially all fields are zero
for (unsigned int i = 0; i < Size; i++)
for (unsigned int j = 0; j < Size; j++)
for (unsigned int k = 0; k < Size; k++)
result(i,k) += get(j,k) * other.get(i,j);
return result;
}
// fast exponentiation with modulo
Matrix powmod(unsigned long long exponent, unsigned int modulo) const
{
// more or less the same concept as powmod from my toolbox (which works on integers instead of matrices)
// start with identity matrix
Matrix result;
for (unsigned int i = 0; i < Size; i++)
result(i,i) = 1;
Matrix base = *this;
while (exponent > 0)
{
// fast exponentation:
// odd exponent ? a^b = a*a^(b-1)
if (exponent & 1)
{
result = result * base;
// modulo
for (unsigned int i = 0; i < Size; i++)
for (unsigned int k = 0; k < Size; k++)
result(i,k) = result(i,k) % modulo;
}
// even exponent ? a^b = (a*a)^(b/2)
base = base * base;
// modulo
for (unsigned int i = 0; i < Size; i++)
for (unsigned int k = 0; k < Size; k++)
base(i,k) = base(i,k) % modulo;
exponent >>= 1;
}
return result;
}
};
// solve "almost instantly", too fast to measure execution time ...
unsigned long long fast(unsigned long long numLetters)
{
// same concept as slow() but rewritten with Matrix
// state transitions
Matrix<unsigned long long, 8> mat;
mat(0,0) = 0; mat(1,0) = 0; mat(2,0) = 0; mat(3,0) = 0; mat(4,0) = 0; mat(5,0) = 0; mat(6,0) = 0; mat(7,0) = 0;
mat(0,1) = 7; mat(1,1) = 1; mat(2,1) = 1; mat(3,1) = 1; mat(4,1) = 1; mat(5,1) = 1; mat(6,1) = 1; mat(7,1) = 0;
mat(0,2) = 0; mat(1,2) = 6; mat(2,2) = 1; mat(3,2) = 1; mat(4,2) = 1; mat(5,2) = 1; mat(6,2) = 1; mat(7,2) = 0;
mat(0,3) = 0; mat(1,3) = 0; mat(2,3) = 5; mat(3,3) = 1; mat(4,3) = 1; mat(5,3) = 1; mat(6,3) = 1; mat(7,3) = 0;
mat(0,4) = 0; mat(1,4) = 0; mat(2,4) = 0; mat(3,4) = 4; mat(4,4) = 1; mat(5,4) = 1; mat(6,4) = 1; mat(7,4) = 0;
mat(0,5) = 0; mat(1,5) = 0; mat(2,5) = 0; mat(3,5) = 0; mat(4,5) = 3; mat(5,5) = 1; mat(6,5) = 1; mat(7,5) = 0;
mat(0,6) = 0; mat(1,6) = 0; mat(2,6) = 0; mat(3,6) = 0; mat(4,6) = 0; mat(5,6) = 2; mat(6,6) = 1; mat(7,6) = 0;
mat(0,7) = 0; mat(1,7) = 0; mat(2,7) = 0; mat(3,7) = 0; mat(4,7) = 0; mat(5,7) = 0; mat(6,7) = 1; mat(7,7) = 7;
// note: I could have skipped all those mat(x,y) = 0 because all cell are initialized with zero anyway
// exponentiate matrix
auto superMatrix = mat.powmod(numLetters, Modulo);
// the number of strings WITH the word "project" (number of ways to transition from state 0 to 7)
auto withProject = superMatrix.get(0,7);
// total number of combinations is 7^numLetters
// => I could use powmod(7, 10^12, Modulo) from my toolbox, but there's a 7 in the lower-right corner of the matrix at 7,7
// and since it's exponated as well, it becomes (7^numLetters) % Modulo and that's just what I need
auto all = superMatrix.get(7,7); // and surprisingly 7^(10^12) % 10^9 = 1 !
// without = all - with, but avoid negative results (due to modulo)
if (all < withProject)
all += Modulo;
return all - withProject;
}
int main()
{
unsigned long long limit = 1000000000000ULL; // 10^12
std::cin >> limit;
//std::cout << bruteForce(limit) << std::endl;
//std::cout << slow(limit) << std::endl;
std::cout << fast(limit) << std::endl;
return 0;
}
This solution contains 37 empty lines, 54 comments and 2 preprocessor commands.
Benchmark
The correct solution to the original Project Euler problem was found in less than 0.01 seconds on an Intel® Core™ i7-2600K CPU @ 3.40GHz.
(compiled for x86_64 / Linux, GCC flags: -O3 -march=native -fno-exceptions -fno-rtti -std=gnu++11 -DORIGINAL
)
See here for a comparison of all solutions.
Note: interactive tests run on a weaker (=slower) computer. Some interactive tests are compiled without -DORIGINAL
.
Changelog
December 18, 2017 submitted solution
December 18, 2017 added comments
Difficulty
Project Euler ranks this problem at 30% (out of 100%).
Links
projecteuler.net/thread=458 - the best forum on the subject (note: you have to submit the correct solution first)
Python github.com/Meng-Gen/ProjectEuler/blob/master/458.py (written by Meng-Gen Tsai)
Those links are just an unordered selection of source code I found with a semi-automatic search script on Google/Bing/GitHub/whatever.
You will probably stumble upon better solutions when searching on your own.
Maybe not all linked resources produce the correct result and/or exceed time/memory limits.
Heatmap
Please click on a problem's number to open my solution to that problem:
green | solutions solve the original Project Euler problem and have a perfect score of 100% at Hackerrank, too | |
yellow | solutions score less than 100% at Hackerrank (but still solve the original problem easily) | |
gray | problems are already solved but I haven't published my solution yet | |
blue | solutions are relevant for Project Euler only: there wasn't a Hackerrank version of it (at the time I solved it) or it differed too much | |
orange | problems are solved but exceed the time limit of one minute or the memory limit of 256 MByte | |
red | problems are not solved yet but I wrote a simulation to approximate the result or verified at least the given example - usually I sketched a few ideas, too | |
black | problems are solved but access to the solution is blocked for a few days until the next problem is published | |
[new] | the flashing problem is the one I solved most recently |
I stopped working on Project Euler problems around the time they released 617.
1 | 2 | 3 | 4 | 5 | 6 | 7 | 8 | 9 | 10 | 11 | 12 | 13 | 14 | 15 | 16 | 17 | 18 | 19 | 20 | 21 | 22 | 23 | 24 | 25 |
26 | 27 | 28 | 29 | 30 | 31 | 32 | 33 | 34 | 35 | 36 | 37 | 38 | 39 | 40 | 41 | 42 | 43 | 44 | 45 | 46 | 47 | 48 | 49 | 50 |
51 | 52 | 53 | 54 | 55 | 56 | 57 | 58 | 59 | 60 | 61 | 62 | 63 | 64 | 65 | 66 | 67 | 68 | 69 | 70 | 71 | 72 | 73 | 74 | 75 |
76 | 77 | 78 | 79 | 80 | 81 | 82 | 83 | 84 | 85 | 86 | 87 | 88 | 89 | 90 | 91 | 92 | 93 | 94 | 95 | 96 | 97 | 98 | 99 | 100 |
101 | 102 | 103 | 104 | 105 | 106 | 107 | 108 | 109 | 110 | 111 | 112 | 113 | 114 | 115 | 116 | 117 | 118 | 119 | 120 | 121 | 122 | 123 | 124 | 125 |
126 | 127 | 128 | 129 | 130 | 131 | 132 | 133 | 134 | 135 | 136 | 137 | 138 | 139 | 140 | 141 | 142 | 143 | 144 | 145 | 146 | 147 | 148 | 149 | 150 |
151 | 152 | 153 | 154 | 155 | 156 | 157 | 158 | 159 | 160 | 161 | 162 | 163 | 164 | 165 | 166 | 167 | 168 | 169 | 170 | 171 | 172 | 173 | 174 | 175 |
176 | 177 | 178 | 179 | 180 | 181 | 182 | 183 | 184 | 185 | 186 | 187 | 188 | 189 | 190 | 191 | 192 | 193 | 194 | 195 | 196 | 197 | 198 | 199 | 200 |
201 | 202 | 203 | 204 | 205 | 206 | 207 | 208 | 209 | 210 | 211 | 212 | 213 | 214 | 215 | 216 | 217 | 218 | 219 | 220 | 221 | 222 | 223 | 224 | 225 |
226 | 227 | 228 | 229 | 230 | 231 | 232 | 233 | 234 | 235 | 236 | 237 | 238 | 239 | 240 | 241 | 242 | 243 | 244 | 245 | 246 | 247 | 248 | 249 | 250 |
251 | 252 | 253 | 254 | 255 | 256 | 257 | 258 | 259 | 260 | 261 | 262 | 263 | 264 | 265 | 266 | 267 | 268 | 269 | 270 | 271 | 272 | 273 | 274 | 275 |
276 | 277 | 278 | 279 | 280 | 281 | 282 | 283 | 284 | 285 | 286 | 287 | 288 | 289 | 290 | 291 | 292 | 293 | 294 | 295 | 296 | 297 | 298 | 299 | 300 |
301 | 302 | 303 | 304 | 305 | 306 | 307 | 308 | 309 | 310 | 311 | 312 | 313 | 314 | 315 | 316 | 317 | 318 | 319 | 320 | 321 | 322 | 323 | 324 | 325 |
326 | 327 | 328 | 329 | 330 | 331 | 332 | 333 | 334 | 335 | 336 | 337 | 338 | 339 | 340 | 341 | 342 | 343 | 344 | 345 | 346 | 347 | 348 | 349 | 350 |
351 | 352 | 353 | 354 | 355 | 356 | 357 | 358 | 359 | 360 | 361 | 362 | 363 | 364 | 365 | 366 | 367 | 368 | 369 | 370 | 371 | 372 | 373 | 374 | 375 |
376 | 377 | 378 | 379 | 380 | 381 | 382 | 383 | 384 | 385 | 386 | 387 | 388 | 389 | 390 | 391 | 392 | 393 | 394 | 395 | 396 | 397 | 398 | 399 | 400 |
401 | 402 | 403 | 404 | 405 | 406 | 407 | 408 | 409 | 410 | 411 | 412 | 413 | 414 | 415 | 416 | 417 | 418 | 419 | 420 | 421 | 422 | 423 | 424 | 425 |
426 | 427 | 428 | 429 | 430 | 431 | 432 | 433 | 434 | 435 | 436 | 437 | 438 | 439 | 440 | 441 | 442 | 443 | 444 | 445 | 446 | 447 | 448 | 449 | 450 |
451 | 452 | 453 | 454 | 455 | 456 | 457 | 458 | 459 | 460 | 461 | 462 | 463 | 464 | 465 | 466 | 467 | 468 | 469 | 470 | 471 | 472 | 473 | 474 | 475 |
476 | 477 | 478 | 479 | 480 | 481 | 482 | 483 | 484 | 485 | 486 | 487 | 488 | 489 | 490 | 491 | 492 | 493 | 494 | 495 | 496 | 497 | 498 | 499 | 500 |
501 | 502 | 503 | 504 | 505 | 506 | 507 | 508 | 509 | 510 | 511 | 512 | 513 | 514 | 515 | 516 | 517 | 518 | 519 | 520 | 521 | 522 | 523 | 524 | 525 |
526 | 527 | 528 | 529 | 530 | 531 | 532 | 533 | 534 | 535 | 536 | 537 | 538 | 539 | 540 | 541 | 542 | 543 | 544 | 545 | 546 | 547 | 548 | 549 | 550 |
551 | 552 | 553 | 554 | 555 | 556 | 557 | 558 | 559 | 560 | 561 | 562 | 563 | 564 | 565 | 566 | 567 | 568 | 569 | 570 | 571 | 572 | 573 | 574 | 575 |
576 | 577 | 578 | 579 | 580 | 581 | 582 | 583 | 584 | 585 | 586 | 587 | 588 | 589 | 590 | 591 | 592 | 593 | 594 | 595 | 596 | 597 | 598 | 599 | 600 |
601 | 602 | 603 | 604 | 605 | 606 | 607 | 608 | 609 | 610 | 611 | 612 | 613 | 614 | 615 | 616 | 617 | 618 | 619 | 620 | 621 | 622 | 623 | 624 | 625 |
626 | 627 | 628 | 629 | 630 | 631 | 632 | 633 | 634 | 635 | 636 | 637 | 638 | 639 | 640 | 641 | 642 | 643 | 644 | 645 | 646 | 647 | 648 | 649 | 650 |
651 | 652 | 653 | 654 | 655 | 656 | 657 | 658 | 659 | 660 | 661 | 662 | 663 | 664 | 665 | 666 | 667 | 668 | 669 | 670 | 671 | 672 | 673 | 674 | 675 |
676 | 677 | 678 | 679 | 680 | 681 | 682 | 683 | 684 | 685 | 686 | 687 | 688 | 689 | 690 | 691 | 692 | 693 | 694 | 695 | 696 | 697 | 698 | 699 | 700 |
701 | 702 | 703 | 704 | 705 | 706 | 707 | 708 | 709 | 710 | 711 | 712 | 713 | 714 | 715 | 716 | 717 | 718 | 719 | 720 | 721 | 722 | 723 | 724 | 725 |
726 | 727 | 728 | 729 | 730 | 731 | 732 | 733 | 734 | 735 | 736 | 737 | 738 | 739 | 740 | 741 | 742 | 743 | 744 | 745 | 746 | 747 | 748 | 749 | 750 |
751 | 752 | 753 | 754 | 755 | 756 | 757 | 758 | 759 | 760 | 761 | 762 | 763 | 764 | 765 | 766 | 767 | 768 | 769 | 770 | 771 | 772 | 773 | 774 | 775 |
776 | 777 | 778 | 779 | 780 | 781 | 782 | 783 | 784 | 785 | 786 | 787 | 788 | 789 | 790 | 791 | 792 | 793 | 794 | 795 | 796 | 797 | 798 | 799 | 800 |
801 | 802 | 803 | 804 | 805 | 806 | 807 | 808 | 809 | 810 | 811 | 812 | 813 | 814 | 815 | 816 | 817 | 818 | 819 |
I scored 13526 points (out of 15700 possible points, top rank was 17 out of ≈60000 in August 2017) at Hackerrank's Project Euler+.
My username at Project Euler is stephanbrumme while it's stbrumme at Hackerrank.
Look at my progress and performance pages to get more details.
Copyright
I hope you enjoy my code and learn something - or give me feedback how I can improve my solutions.
All of my solutions can be used for any purpose and I am in no way liable for any damages caused.
You can even remove my name and claim it's yours. But then you shall burn in hell.
The problems and most of the problems' images were created by Project Euler.
Thanks for all their endless effort !!!
<< problem 455 - Powers With Trailing Digits | Almost Pi - problem 461 >> |